
local assets =
{
    Asset("ANIM", "anim/house1.zip"),
}

local prefabs = 
{
}

local function turnon(inst)
    if not inst.components.fueled:IsEmpty() then
    if not inst.components.machine.ison then
    if inst.components.fueled then
    inst.components.fueled:StartConsuming()        
    inst.Light:Enable(true)
    inst.AnimState:PlayAnimation("house_on")
    inst.AnimState:PushAnimation("house_on",true)
    inst.components.machine.ison = true
    inst.on = true
    inst.SoundEmitter:PlaySound("dontstarve/wilson/lantern_on")
    inst.SoundEmitter:PlaySound("dontstarve/wilson/lantern_LP", "loop")
	        end
	    end
	end
end

local function turnoff(inst)
    if inst.components.fueled then
    inst.components.fueled:StopConsuming()        
    inst.AnimState:PlayAnimation("house")
    inst.AnimState:PushAnimation("house",true)
    inst.Light:Enable(false)
    inst.components.machine.ison = false
    inst.on = false
    inst.SoundEmitter:KillSound("loop")
    inst.SoundEmitter:PlaySound("dontstarve/wilson/lantern_off")
	end
end

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
	inst:Remove()
end

local function onhit(inst, worker)
end

local function onfinished(inst)
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
    inst:Remove()              
end

local function wakeuptest(inst, phase)
    if phase ~= "night" then
    inst:PushEvent("wake")
    end
end

local function onwake(inst, sleeper)    
    if inst.sleeptask ~= nil then
    inst.sleeptask:Cancel()
    inst.sleeptask = nil
end
    inst:StopWatchingWorldState("phase", wakeuptest)
    sleeper.sg:GoToState("wakeup")
    inst.AnimState:PushAnimation("house", true)
    inst.components.finiteuses:Use()
end

local function onhousetick(inst, sleeper)
    if sleeper.components.hunger ~= nil then
        -- Check SGwilson, state "bedroll", if you change this value
        sleeper.components.hunger:DoDelta(TUNING.SLEEP_HUNGER_PER_TICK, true, true)
end
    if sleeper.components.sanity ~= nil and sleeper.components.sanity:GetPercentWithPenalty() < 1 then
        sleeper.components.sanity:DoDelta(TUNING.SLEEP_SANITY_PER_TICK, true)
end
    if sleeper.components.health ~= nil and (not sleeper.components.hunger or sleeper.components.hunger:GetPercent() > 0) then
        sleeper.components.health:DoDelta(TUNING.SLEEP_HEALTH_PER_TICK * 2, true, "tent", true)
end
    if sleeper.components.temperature ~= nil then
        sleeper.components.temperature:SetTemperature(sleeper.components.temperature:GetCurrent() + TUNING.SLEEP_TEMP_PER_TICK) 
    end
end

local function onsleep(inst, sleeper)
    -- check if we're in an invalid period (i.e. daytime). if so: wakeup
    inst:WatchWorldState("phase", wakeuptest)
    -- "occupied" anim
    inst.AnimState:PlayAnimation("house", true)
    if inst.sleeptask ~= nil then
    inst.sleeptask:Cancel()
end
    inst.sleeptask = inst:DoPeriodicTask(TUNING.HOUSE_TICK_PERIOD, onhousetick, nil, sleeper)
end

local function OnLoad(inst, data)
    if inst.components.machine and inst.components.machine.ison then
    inst.AnimState:PushAnimation("house_on", true)
    turnon(inst)
    inst.Light:Enable(true)
    else
    inst.AnimState:PlayAnimation("house")
    turnoff(inst)
    inst.Light:Enable(false)
    end
end	

local function fuelupdate(inst)
    local fuelpercent = inst.components.fueled:GetPercent()
    inst.Light:SetIntensity(Lerp(0.4, 0.6, fuelpercent))
    inst.Light:SetRadius(Lerp(4, 6, fuelpercent))
    inst.Light:SetFalloff(.7)
end

local function getstatus(inst, viewer)
	if inst.on then
	if inst.components.fueled and (inst.components.fueled.currentfuel / inst.components.fueled.maxfuel) <= .25 then
	return "LOWFUEL"
	else
	return "ON"
end
	else
	return "OFF"
	end
end

local function fn(Sim)
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()
    inst.entity:AddNetwork()	

    local light = inst.entity:AddLight()
    inst.Light:Enable(false)
    inst.Light:SetRadius(1.5)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(.5)
    inst.Light:SetColour(180/255, 195/255, 150/255)
    
    inst.entity:AddSoundEmitter()

    if not TheWorld.ismastersim then
    return inst
end
    inst.entity:SetPristine()    

    inst:AddTag("structure")    
    inst:AddTag("tent")
    inst:AddTag("nosleepanim")    
    inst:AddTag("shelter")

    inst.AnimState:SetBank("house")
    inst.AnimState:SetBuild("house")
    inst.AnimState:PushAnimation("house", true)    
   
    inst:AddComponent("lootdropper")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(4)
    inst.components.workable:SetOnFinishCallback(onhammered)
    inst.components.workable:SetOnWorkCallback(onhit)     

    MakeObstaclePhysics(inst, 2)    

    inst.MiniMapEntity:SetIcon("house.tex")

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(LIL_USAGE)
    inst.components.finiteuses:SetUses(LIL_USAGE)
    inst.components.finiteuses:SetOnFinished(onfinished)
	    
    inst:AddComponent("sleepingbag")
    inst.components.sleepingbag.onsleep = onsleep
    inst.components.sleepingbag.onwake = onwake

    inst:AddComponent("fueled")

    inst:AddComponent("machine")
    inst.components.machine.turnonfn = turnon
    inst.components.machine.turnofffn = turnoff
    inst.components.machine.cooldowntime = 0
    inst.components.machine.caninteractfn = function()
    return not inst.components.fueled:IsEmpty() end

	inst:AddComponent("inspectable")
	inst.components.inspectable.getstatus = getstatus

    inst.components.fueled.fueltype = "CAVE"
    inst.components.fueled:InitializeFuelLevel(TUNING.LANTERN_LIGHTTIME)
    inst.components.fueled:SetDepletedFn(turnoff)
    inst.components.fueled:SetUpdateFn(fuelupdate)
	inst.components.fueled:SetSections(10)
    inst.components.fueled.accepting = true    

    fuelupdate(inst)

    inst.OnLoad = OnLoad

    return inst
end	
	
return Prefab( "common/objects/house1", fn, assets),
		MakePlacer( "common/house1_placer", "house", "house", "house" ) 
